{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/srclicense.html.   }
{ --------------------------------------------------------------- }
{ $Id: xpkeys.pas,v 1.5.2.2 2001/12/22 14:56:48 mm Exp $ }

{ (Funktions)tasten & Makros }

{$I XPDEFINE.INC }
{$IFDEF BP }
  {$F+}
{$ENDIF }

unit xpkeys;

interface

uses
  xpglobal, dos,typeform,fileio,inout,keys,resource,xp0,xp1;


type  getf_func   = function(nr,nn:byte):pathstr;
var   getfilename : getf_func;
const FuncExternal: boolean = false;    { *-Funktionen gesperrt }
      PreExtProc  : procedure = nil;


procedure prog_call(nr,nn:byte);
function  test_fkeys(var t:taste):boolean;
procedure Xmakro(var t:taste; flags:byte);


const k0_S  : char = 'S';      { Spezial-Mode         }
      k0_A  : char = 'A';      { Alle Bretter         }
      k0_H  : char = 'H';      { Brett hinzufgen     }
      k0_cH : char = ^H;       { aus Maps-Liste anlg. }
      k0_L  : char = 'L';      { Brett lschen        }
      k0_E  : char = 'E';      { Brett editieren      }
      k0_V  : char = 'V';      { Bretter verknpfen   }
      k0_cT : char = ^T;       { Trennzeile einfgen  }
      k0_P  : char = 'P';      { Bretter verschieben  }
      k0_Le : char = 'L';      { Lesemode setzen      }
      k0_B  : char = 'b';      { Brettbrief           }
      k0_SB : char = 'B';      { Brett-Crossposting   }
      k0_I  : char = 'I';      { Binrdatei senden    }
      k0_TE : char = 'E';      { Textdatei senden     }
      k0_cG : char = ^G;       { Brettgruppe mark.    }
      k0_cE : char = ^E;       { Bretter entmark.     }
      k0_cW : char = ^W;       { Brettweiterschalter  }
      k0_cF : char = ^F;       { Satznummer           }
      k0_Ac : char = 'A';      { Spezial / Zugriff    }
      k0_RH : char = 'R';      { Reverse-HDO          }

      k1_S  : char = 'S';      { Spezialmode          }
      k1_A  : char = 'A';      { Adrebuch-Umschalter }
      k1_H  : char = 'H';      { User hinzufgen      }
      k1_V  : char = 'V';      { Verteiler anlegen    }
      k1_L  : char = 'L';      { User lschen         }
      k1_E  : char = 'E';      { User editieren       }
      k1_cV : char = ^V;       { Userbretter verkn.   }
      k1_B  : char = 'b';      { Userbrief            }
      k1_SB : char = 'B';      { User-Crossposting    }
      k1_I  : char = 'I';      { Binrdatei senden    }
      k1_TE : char = 'E';      { Textdatei senden     }
      k1_R  : char = 'R';      { Adrebuch ein/austr. }
      k1_P  : char = 'P';      { Pawort ndern       }
      k1_cE : char = ^E;       { User entmarkieren    }
      k1_cW : char = ^W;       { Userweiterschalter   }
      k1_U  : char = 'U';      { Usersuche            }

      k2_S  : char = 'S';      { Spezial-Men         }
      k2_cR : char = ^R;       { Rot13                }
      k2_cH : char = ^H;       { Hex-Dump             }
      k2_I  : char = 'I';      { Info-Fenster         }
      k2_O  : char = 'O';      { Originalheader       }
      k2_H  : char = 'H';      { Halten               }
      k2_L  : char = 'L';      { Lschen              }
      k2_K  : char = 'K';      { Kill                 }
      k2_cU : char = ^U;       { UserEdit             }
      k2_V  : char = 'V';      { Wiedervorlage        }
      k2_cE : char = ^E;       { Nachrichten entmark. }
      k2_U  : char = 'U';      { User-Fenster         }
      k2_cF : char = ^F;       { Textdatei senden     }
      k2_cI : char = ^I;       { Binrdatei senden    }
      k2_G  : char = 'G';      { Bezugssuche          }
      k2_cA : char = ^A;       { Fido-Anzeige umsch.  }
      k2_KA : char = 'A';      { Adreanzeige im Baum }
      k2_EA : char = 'A';      { Empfngeranzeige     }
      k2_cW : char = ^W;       { Weiterschalter       }
      k2_cD : char = ^D;       { Drucken              }
      k2_cS : char = ^S;       { Datumsanzeige        }
      k2_R  : char = 'r';      { HdrOnly-Req. o. Ausw.}
      k2_cN : char = ^N;       { Realnameanzeige      }
      k2_BB : char = '#';      { Kommentarbaum        }
      k2_A  : char = 'A';      { unversandt <-> Alle  }
      k2_b  : char = 'b';      { Brettbrief           }
      k2_cB : char = ^B;       { Quote-Brettbrief     }
      k2_SB : char = 'B';      { Multiquote           }
      k2_p  : char = 'p';      { PM                   }
      k2_cP : char = ^P;       { Quote-PM             }
      k2_SP : char = 'P';      { Multiquote-PM        }
      k2_cT : char = ^T;       { User-Pawort-Edit    }
      k2_cQ : char = ^Q;       { indirekter Fido-Quote}
      k2_SR : char = 'R';      { HdrOnly-Req. m. Ausw.}

      k3_H  : char = 'H';      { neuer AV-Eintrag     }
      k3_E  : char = 'E';      { AutoVersand Edit     }
      k3_L  : char = 'L';      { lschen              }
      k3_A  : char = 'A';      { aktiv                }
      k3_T  : char = 'T';      { TextEdit             }
      k3_I  : char = 'I';      { Fileinfo             }
      k3_S  : char = 'S';      { Autoversand Senden   }
      k3_K  : char = 'K';      { Eintrag kopieren     }

      k4_D  : char = 'D';      { Drucken im Lister    }
      k4_W  : char = 'W';      { in Datei schreiben   }
      k4_L  : char = 'L';      { Nachricht lschen    }
      k4_cL : char = ^L;       { .. und drinbleiben   }
      k4_H  : char = 'H';      { Nachricht halten     }
      k4_F  : char = 'F';      { Farbumschaltung      }


implementation  { -------------------------------------------------- }

uses xp4o,xp7,xp9,xpauto;


{ Funktionstaste in Hauptfenster oder ArcViewer }

procedure prog_call(nr,nn:byte);
var s      : string;
    p0     : byte;
    fn,fn2 : pathstr;
    brk    : boolean;
    auto   : boolean;
    ende   : boolean;
begin
  with fkeys[nr]^[nn] do begin
    s:=prog;
    auto:=autoexec;
    if s[1]='*' then begin
      if funcexternal then exit;
      s:=ustr(trim(s));
      if copy(s,2,7)='NETCALL' then
        EinzelNetcall(trim(copy(s,10,BoxNameLen)))
      else if copy(s,2,8)='RNETCALL' then
        netcall(true,trim(copy(s,11,BoxNameLen)),false,true,false)
      else if mid(s,2)='REORG' then begin
        MsgReorgScan(true,false,brk);
        if not brk then MsgReorg;
        end
      else if copy(s,2,7)='SETUSER' then
        SetUsername(mid(trim(prog),10))    { in XP9 }
      else if copy(s,2,4)='LIST' then begin
        fn:=trim(mid(s,7));
        if exist(fn) then
          if listfile(fn,fn,true,false,0)<>0 then
          else
          repeat
	    if listfile(fn,fn,true,false,0) = -4 then ende:=false
	    else ende:=true;
	  until ende
        else
          rfehler(20);   { '*LIST: Datei nicht vorhanden!' }
        end
      else if copy(s,2,4)='EDIT' then begin
        fn:=trim(mid(s,7));
        if exist(fn) then
          editfile(fn,false,false,0,false)
        else
          rfehler(23)    { '*EDIT: Datei nicht vorhanden!' }
        end
      else if mid(s,2)='AUTOEXEC' then
        auto:=true
      else if s<>'*' then
        rfehler1(21,left(s,50));   { 'Ungltige Funktion:  %s' }
      end
    else if s<>'' then begin
      p0:=pos('$FILE',ustr(s));
      if p0>0 then begin
        fn:=getfilename(nr,nn);
        if (fn='') or not exist(fn) then exit;
        s:=copy(s,1,p0-1)+fn+copy(s,p0+5,120);
        end;
      if @preextproc<>nil then begin
        preextproc;
        preextproc:=nil;
        end;
      shellkey:=warten;
      if listout then begin
        fn2:=TempFile(TempPath);
        shell(s+'>'+fn2,speicher,0);
        if listfile(fn2,'',true,false,0)<>0 then;
        if exist(fn2) then era(fn2);
        end
      else
        shell(s,speicher,iif(vollbild,1,3));
      if (p0>0) and not bname and (exist(fn)) then
        era(fn);
      end;
    if auto then
      if (s='') and not exist(AutoxDir+'\*.*') then
        hinweis(getres(150))   { 'keine Dateien im AUTOEXEC-Verzeichnis vorhanden' }
      else
        xpauto.AutoExec(false);
    end;
end;

function test_fkeys(var t:taste):boolean;
var nr,n : shortint;
begin
  test_fkeys:=false;
  nr:=0;
  if (t>=keysf1) and (t<=keysf10) then nr:=1
  else if (t>=keycf1) and (t<=keycf10) then nr:=2
  else if (t>=keyaf1) and (t<=keyaf10) then nr:=3;
  if nr>0 then begin
    n:=(ord(t[2])-84)mod 10+1;
    if fkeys[nr]^[n].prog<>'' then begin
      prog_call(nr,n);
      test_fkeys:=true;
      end;
    end;
end;


{ flags:  1 = Bretter, 2 = User, 4 = Msgs, 8=Lister, 16=ArcViewer, 32=Editor,
          64 = Terminal }

procedure Xmakro(var t:taste; flags:byte);
var i : integer;
    s : string;
begin
  i:=1;
  while (i<=keymacros) and ((macroflags[i] and flags=0) or (t<>macrokey[i])) do
    inc(i);
  if i<=keymacros then begin
    s:=macrodef[i]^;
    if s[1]=#0 then t:=left(s,2)
    else t:=s[1];
    insert(mid(s,length(t)+1),forwardkeys,1);
    end;
end;

end.
{
  $Log: xpkeys.pas,v $
  Revision 1.5.2.2  2001/12/22 14:56:48  mm
  - ListWrapToggle: mittels Ctrl-W kann im Lister und Archiv-Viewer der
    automatische Wortumbruch nicht-permanent umgeschaltet werden
    (Dank an Michael Heydekamp)

  Revision 1.5.2.1  2001/07/28 07:53:34  MH
  - Taste 'Ne^w' (englisch) im Specialmode wieder hergestellt

  Revision 1.5  2000/09/24 00:42:06  MH
  Requester nun auf R-Taste (deutsch) und G-Taste (englisch)

  Revision 1.4  2000/04/09 18:31:31  openxp
  Aktualisiert mit Source vom 09.04.2000 des OpenXP Teams

  Revision 1.5  2000/02/19 11:40:09  mk
  Code aufgeraeumt und z.T. portiert

}
