{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{                                                                 }
{ Aenderungen des XP2 Teams unterliegen urheberrechtlich          }
{ dem XP2 Team, weitere Informationen unter: http://www.xp2.de    }
{                                                                 }
{ Basierend auf der Sourcebuild vom 09.04.2000 des OpenXP Teams.  }
{ Aenderungen des Sources, die vom OpenXP Teams getaetigt wurden, }
{ unterliegen den Rechten, die bis zum 09.04.2000 fuer das OpenXP }
{ Team gueltig waren.                                             }
{                                                                 }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/srclicense.html.   }
{ --------------------------------------------------------------- }
{ $Id: xp9ppp.pas,v 1.24.2.18 2001/12/27 19:23:23 MH Exp $ }


{ --- Bearbeitungs-Routinen fr RFC/PPP-Boxen ------------------- }

{$I XPDEFINE.INC}
{$IFDEF BP }
  {$O+,F+,R-}
{$ENDIF }

unit xp9ppp;

interface

uses xpglobal,crt,dos,typeform,fileio,inout,keys,winxp,win2,maske,
     datadef,database,maus2,mouse,resource,xp0,xp1,xp1o,xp1o2,xp1input,xp2c;

procedure getdname;
function cvtlang(s: string; engtoger: boolean):string;
procedure EditPOP3(var brk:boolean);
procedure EditSMTP(var brk:boolean);
procedure EditNNTP(var brk:boolean);
procedure EditZugang(var brk:boolean);
procedure EditClients(var brk:boolean);

implementation  {-------------------------------------------------}

uses xp2,xp3,xp3o,xp9,xp9bp,xp10,xpnt,xpterm;
  {
  maddint: ...typ,displ,von,bis
  Typ 2 = ShortInt, 3 = Byte, 4 = Integer, 5 = Word, 6 = LongInt
  }

  const
    dname : string[9] = '';

  procedure getdname;
  var
    d          : DB;
  begin
    dbOpen(d,BoxenFile,1);
    dbSeek(d,boiName,ustr(BoxPar^.BoxName));
    if dbFound then begin
      dbRead(d,'dateiname',dname);
      dname:=dname+'\';
    end
    else
      dname:=ustr(left(BoxPar^.BoxName,8))+'\';
    dbClose(d);
  end;

  function cvtlang(s: string; engtoger: boolean):string;
  var
    s1,s2: string[110];
    p    : byte;
  begin
    s:=trim(s); s2:='';
    repeat
      p:=blankpos(s);
      if p=0 then p:=length(s)+1;
      s1:=left(s,p-1);
      s:=trim(mid(s,p));
      if engtoger then
        if lstr(s1)='enabled' then s2:=s2+'aktiviert ' else
        if lstr(s1)='disabled' then s2:=s2+'deaktiviert ' else
        s2:=s2+s1+' '
      else
        if lstr(s1)='aktiviert' then s2:=s2+'enabled ' else
        if lstr(s1)='deaktiviert' then s2:=s2+'disabled ' else
        s2:=s2+s1+' ';
    until s='';
    cvtlang:=rtrim(s2);
  end;

  procedure EditPOP3(var brk:boolean);
  var x,y: byte;
  begin
    dialog(51,17,getres2(936,1),x,y);  { 'POP3-Einstellungen' }
    with BoxPar^ do begin
      Pop3UseEnvelope:=cvtlang(Pop3UseEnvelope,deutsch);
      Pop3Keep:=cvtlang(Pop3Keep,deutsch);
      Pop3Auth:=cvtlang(Pop3Auth,deutsch);
      maddstring(3,2,getres2(936,6)+sp(4),Pop3Server,32,200,'');       { 'Server     ' }
      mappsel(false,getres2(936,56));                                  { Serverauswahl }
      mhnr(9000);
      maddstring(3,3,getres2(936,7)+sp(4),Pop3User,32,200,'');         { 'User       ' }
      maddstring(3,4,getres2(936,8)+sp(4),Pop3Pass,32,100,'');         { 'Passwort   ' }
      maddstring(3,5,getres2(936,9)+sp(4),Pop3Envelope,32,200,'');     { 'Envelope   ' }
      maddstring(3,6,getres2(936,10),Pop3UseEnvelope,32,110,'');       { 'UseEnvelope' }
      mappsel(false,getres2(936,54));                                  { 'aktiviertdeaktiviert' }
      maddstring(3,7,getres2(936,11),Pop3Keep,32,110,'');              { 'Keep       ' }
      mappsel(false,getres2(936,54));                                  { 'aktiviertdeaktiviert' }
      maddstring(3,8,getres2(936,12)+sp(4),Pop3Spool,32,255,'');       { 'Spool      ' }
      getdname;
      mappsel(false,iifs(PPP_UUZ_Spool<>OwnPath+XFerDir+dname,PPP_UUZ_Spool,
                         OwnPath+XFerDir)+''+OwnPath+XFerDir+dname);
      maddstring(3,10,getres2(936,53),Pop3Auth,19,110,'');             { 'sichere Authentifizierung verwenden' }
      mappsel(false,getres2(936,54));                                  { 'aktiviertdeaktiviert' }
      maddstring(3,12,getres2(936,13),Pop3Port,10,50,'0123456789 ');   { 'Port       ' }
      mappsel(false,getres2(936,90)); {'11025143585993'}           { Portauswahl }
      maddint(27,12,getres2(936,14),Pop3TimeOut,4,3,0,300);            { 'TimeOut    ' }
      mappsel(false,getres2(936,91)); {'1020306090120180240300'}
      maddtext(length(getres2(936,14))+34,12,getres2(936,61),0);
      maddint(3,14,getres2(936,51),Pop3MaxLen,6,7,0,9999999);          { 'MaxLen   ' }
      mappsel(false,getres2(936,97)+getres2(936,96));
      {'0819216384327686553613107226214452428810485762621440524288078643209999999'}
      maddtext(length(getres2(936,51))+14,14,' Bytes',0);
      maddbool(3,16,getres2(936,43),IMAP);                             { 'POP3/IMAP  ' }
      freeres;
      readmask(brk);
      Pop3UseEnvelope:=cvtlang(Pop3UseEnvelope,false);
      Pop3Keep:=cvtlang(Pop3Keep,false);
      Pop3Auth:=cvtlang(Pop3Auth,false);
      enddialog;
    end;
  end;

  procedure EditSMTP(var brk:boolean);
  var x,y: byte;
  begin
    dialog(51,16,getres2(936,2),x,y);  { 'SMTP-Einstellungen' }
    with BoxPar^ do begin
      maddstring(3,2,getres2(936,6),SmtpServer,36,200,'');           { 'Server         ' }
      mappsel(false,getres2(936,57));                                { Serverauswahl }
      mhnr(9020);
      maddstring(3,3,getres2(936,7),SmtpUser,36,200,'');             { 'User           ' }
      maddstring(3,4,getres2(936,8),SmtpPass,36,100,'');             { 'Passwort       ' }
      maddstring(3,5,getres2(936,9),SmtpEnvelope,36,200,'');         { 'Envelope       ' }
      maddstring(3,6,getres2(936,12),SmtpSpool,36,255,'');           { 'Spool          ' }
      getdname;
      mappsel(false,iifs(PPP_UUZ_Spool<>OwnPath+XFerDir+dname,PPP_UUZ_Spool,
                         OwnPath+XFerDir)+''+OwnPath+XFerDir+dname);
      SmtpAuth:=cvtlang(SmtpAuth,deutsch);
      maddstring(3,8,getres2(936,53),SmtpAuth,19,110,'');            { 'sichere Authentifizierung verwenden' }
      mappsel(false,getres2(936,55)); { 'aktiviertdeaktiviertautoLoginPlainDigest-MD5Cram-MD5' }
      maddbool(3,10,getres2(936,15),SmtpAfterPop);                   { 'AfterPop       ' }
      maddstring(3,12,getres2(936,13),SmtpPort,10,50,'0123456789 '); { 'Port           ' }
      mappsel(false,getres2(936,101)); {'25'}                        { Portauswahl }
      maddint(27,12,getres2(936,14),SmtpTimeOut,4,3,0,300);          { 'TimeOut        ' }
      mappsel(false,getres2(936,91)); {'1020306090120180240300'}
      maddtext(length(getres2(936,14))+34,12,getres2(936,61),0);
      maddint(3,14,getres2(936,16),SmtpAfterPopTimeOut,4,3,0,300);  { 'AfterPopTimeOut' }
      mappsel(false,getres2(936,91)); {'1020306090120180240300'}
      maddtext(length(getres2(936,16))+10,14,getres2(936,61),0);
      maddint(3,15,getres2(936,17),SmtpAfterPopDelay,4,3,0,300);    { 'AfterPopDelay  ' }
      mappsel(false,'0'+getres2(936,92)+getres2(936,93));
      {'012345101520306090120180240300'}
      maddtext(length(getres2(936,17))+10,15,getres2(936,61),0);
      freeres;
      readmask(brk);
      SmtpAuth:=cvtlang(SmtpAuth,false);
      enddialog;
    end;
  end;

  procedure EditNNTP(var brk:boolean);
  var x,y: byte;

  {$IFDEF MAXy}

  function readbutt(scronly:boolean):byte;
  var
    rbx,rby: shortint;
    button : string[11];
    t      : taste;
  begin
    button:='^Multi-Nntp';
    if scronly then t:='!' else t:='*';
    if auswahlcursor then begin { Blindenunterttzung }
      rbx:=x+1; rby:=y+1;
    end;
    pushhp(910);
    readbutt:=readbutton(x+35,y+19,1,button,1,false,t);
    pophp;
  end;
 {$ENDIF}

  begin
  {$IFDEF MAXy}
    dialog(54,21,getres2(936,3),x,y);  { 'NNTP-Einstellungen' }
  {$ELSE}
    dialog(54,19,getres2(936,3),x,y);  { 'NNTP-Einstellungen' }
  {$ENDIF}
    with BoxPar^ do begin
      maddstring(3,2,getres2(936,6),NntpServer,39,200,without(range('-','z'),'/:;<=>?@[\]^'));    { 'Server   ' }
      mappsel(false,getres2(936,58));                         { Serverauswahl }
      mhnr(9040);
      maddstring(3,3,getres2(936,7),NntpUser,39,200,'');      { 'User     ' }
      maddstring(3,4,getres2(936,8),NntpPass,39,100,'');      { 'Passwort ' }
      maddstring(3,5,getres2(936,12),NntpSpool,39,255,without(range('-','z')+'#','/;<=>?@[]^'));    { 'Spool    ' }
      getdname;
      mappsel(false,iifs(PPP_UUZ_Spool<>OwnPath+XFerDir+dname,PPP_UUZ_Spool,
                         OwnPath+XFerDir)+''+OwnPath+XFerDir+dname);
      msetVfunc(formpath);
      maddint(3,7,getres2(936,13),NntpPort,6,5,0,65535);      { 'Port     ' }
      mappsel(false,'119');                                   { Portauswahl }
      maddint(30,7,getres2(936,14),NntpTimeOut,4,3,0,300);    { 'TimeOut        ' }
      mappsel(false,getres2(936,91)); {'1020306090120180240300'}
      maddtext(length(getres2(936,14))+37,7,getres2(936,61),0);
      maddbool(3,9,getres2(936,18),NntpList);                 { 'Newsliste' }
      maddbool(3,10,getres2(936,19),NntpRescan);              { 'Rescan   ' }
      maddbool(3,11,getres2(936,49),NntpPosting);             { 'Posting   ' }
      maddbool(3,12,sp(2)+getres2(936,52),ReplaceOwn);         { 'ReplaceOwn ' }
      maddint(3,14,getres2(936,20),NntpQueue,4,6,1,20);       { 'Queue    ' }
      mappsel(false,getres2(936,92)); {'12345101520'}
      maddint(3,15,getres2(936,45),NntpArtclAnz,4,6,0,32000); { 'Anzahl   ' }
      mappsel(false,getres2(936,98)+getres2(936,100));
      {'010255075100150200250500750100025005000100002000032000'}
      maddint(3,16,getres2(936,21),NntpMaxLen,6,6,0,999999);  { 'MaxLen   ' }
      mappsel(false,getres2(936,97)+'999999');
      {'08192163843276865536131072262144524288786432999999'}
      maddtext(length(getres2(936,21))+13,16,' Bytes',0);
      maddint(3,17,getres2(936,22),NntpNewMax,6,6,0,999999);  { 'NewMax   ' }
      mappsel(false,getres2(936,98)+getres2(936,99));
      {'01025507510025050075010002500500010000250005000075000999999'}
      maddint(3,18,getres2(936,23),NntpDupeSize,6,6,0,999999);{ 'DupeSize ' }
      mappsel(false,getres2(936,97)+'999999');
      {'08192163843276865536131072262144524288786432999999'}
      maddtext(length(getres2(936,23))+13,18,' Bytes',0);
      {$IFDEF MAXy}
      maskdontclear;
      maddtext(3,20,'Multiboxbetrieb konfigurieren',col.coldiahigh);
      {maskcheckbuttons;}
      readbutt(true);
      {$ENDIF}
      freeres;
      readmask(brk);
      {$IFDEF MAXy}
      if not brk and (readbutt(false)=1) then UniEdit(7);
      {$ENDIF}
      enddialog;
    end;
  end;

  procedure EditZugang(var brk:boolean);
  var x,y    : byte;
      DialNr : string[28];
  begin
    {$IFnDEF MAX}
    dialog(46,17,getres2(936,5),x,y);  { 'Zugangs-Einstellungen' }
    {$ELSE}
    dialog(46,14,getres2(936,5),x,y);  { 'Zugangs-Einstellungen' }
    {$ENDIF}
    with BoxPar^ do begin
      DialNr:=DialInNumber;
      maddstring(3,2,getres2(936,24),DialInAccount,26,40,'');           { 'Account       ' }
      mhnr(9060);
      maddstring(3,3,getres2(936,7)+sp(5),DialInUser,26,40,'');         { 'User          ' }
      maddstring(3,4,getres2(936,8)+sp(5),DialInPass,26,25,'');         { 'Passwort      ' }
      maddstring(3,5,getres2(936,25),DialNr,26,28,'0123456789wW');{ 'Rufnummer     ' }
      mappsel(false,getres2(936,59)); {'..0191011..'}
      maddbool(3,7,getres2(936,26),PerformPass);                        { 'Perform Password entry' }
      maddbool(3,8,getres2(936,27),AfterDialinState);                   { 'Disconnect after Dial-In State' }
      maddbool(3,9,getres2(936,28),AskForDisconnect);                   { 'Ask for Disconnect' }
      maddint(3,11,getres2(936,29),RedialOnBusy,4,3,0,999);             { 'Redial on busy' }
      mappsel(false,'0'+getres2(936,92)+getres2(936,95));
      {'0123451015205075100250500750999'}
      maddint(3,12,getres2(936,30),RedialTimeout,4,3,0,999);            { 'Redial TimeOut' }
      mappsel(false,'0'+getres2(936,92)+getres2(936,93)+getres2(936,94));
      {'012345101520306090120180240300600999'}
      maddtext(length(getres2(936,30))+10,12,getres2(936,61),0);
      maddint(3,13,getres2(936,50),HangupTimeout,4,3,0,999);            { 'Verbindung trennen nach' }
      mappsel(false,'0'+getres2(936,92)+getres2(936,93)+getres2(936,94));
      {'012345101520306090120180240300600999'}
      maddtext(length(getres2(936,50))+10,13,getres2(936,61),0);
      {$IFnDEF MAX}
      maddtext(3,15,getres2(936,47),col.coldiahigh);                    { 'Pakete mitsenden' }
      maddstring(3,16,getres2(936,48),PPP_BoxPakete,25,200,'');          { 'Name der Boxen '}
      msetvfunc(TestPPPservers);  { prfen, ob PPP-Box und ob vorhanden ! }
      {$ENDIF}
      freeres;
      readmask(brk);
      if not brk and (DialNr<>DialInNumber) and mmodified then
        DialInNumber:=without(DialNr,without(AllChar,range('0','9')+'wW'));
      enddialog;
    end;
  end;

  procedure EditClients(var brk:boolean);
  var
    x,y        : byte;
    StoreSpool : string[79];
  begin
    dialog(47,9,getres2(936,4),x,y);  { 'Clients-Einstellungen' }
    with BoxPar^ do begin
      StoreSpool:=PPP_UUZ_Spool;
      maddstring(3,2,getres2(936,31),PPP_Dialer,30,79,'');    { 'DialIn  ' }
      mhnr(9080);
      mappsel(false,getres2(936,80)); {'WDIAL.EXE /DIAL $CONFIG'}
      msetvfunc(progtest);
      maddstring(3,3,getres2(936,44),PPP_HangUp,30,79,'');    { 'DialOut ' }
      mappsel(false,getres2(936,81)); {'WDIAL.EXE /HANGUP $CONFIG'}
      msetvfunc(progtest);
      maddstring(3,4,getres2(936,32),PPP_Mail,30,160,'');     { 'Mail    ' }
      mappsel(false,getres2(936,82));
      {'XP3P.EXE -CONFIG:$CONFIG -SMTPE-MAIL.EXE $CONFIG
      E-AGENT.EXE $CONFIGSTART /W G-AGENT.EXE $CONFIG'}
      msetvfunc(progtest);
      maddstring(3,5,getres2(936,33),PPP_News,30,160,'');     { 'News    ' }
      mappsel(false,getres2(936,83)); {'E-NEWS.EXE $CONFIG'}
      msetvfunc(progtest);
      maddstring(3,6,getres2(936,34),PPP_UUZ_In,30,255,'');   { 'UUZ-In  ' }
      mappsel(false,getres2(936,84)); {'UUZ.EXE -uz $SCREENLINES $SPOOL $PUFFER'}
      msetvfunc(uuz_in_test);
      maddstring(3,7,getres2(936,35),PPP_UUZ_Out,30,255,'');  { 'UUZ-Out ' }
      mappsel(false,getres2(936,85)); {'UUZ.EXE -zu -SMTP -ppp -1522 -qp -MIME -absnsstyle $PUFFER $SPOOL'}
      msetvfunc(uuz_out_test);
      maddstring(3,8,getres2(936,46),PPP_UUZ_Spool,30,79,without(range('-','z')+'#','/;<=>?@[]^')); { 'UUZ-Spool ' }
      getdname;
      mappsel(false,iifs(PPP_UUZ_Spool<>OwnPath+XFerDir+dname,PPP_UUZ_Spool,
                         OwnPath+XFerDir)+''+OwnPath+XFerDir+dname);
      msetVfunc(formpath);
      readmask(brk);
      if not brk and (ustr(StoreSpool)<>ustr(PPP_UUZ_Spool)) and
        {'Sollen alle Spooleintrge dieser Box mit UUZ-Spool berschrieben werden'}
        ReadJN(getres2(936,110),false) then begin
        Pop3Spool:=PPP_UUZ_Spool;
        SmtpSpool:=PPP_UUZ_Spool;
        NntpSpool:=PPP_UUZ_Spool;
      end;
      freeres;
      enddialog;
    end;
  end;

end.

{
 $Log: xp9ppp.pas,v $
 Revision 1.24.2.18  2001/12/27 19:23:23  MH
 - Multimen wieder aus NNTP ausgelagert

 Revision 1.24.2.17  2001/09/12 08:32:16  MH
 - DialInNo: Nicht erlaubte Zeichen subtrahieren

 Revision 1.24.2.16  2001/09/11 14:32:15  MH
 letzter co:
 - Ein Feld zu lang

 Revision 1.24.2.15  2001/09/11 14:20:04  MH
 - Optik im Men verbessert
 - Fix: DialInNo zu kurz

 Revision 1.24.2.14  2001/08/20 14:04:24  MH
 - SmtpAuth-Fix: String wurde bei Konvertierung abgesgt

 Revision 1.24.2.13  2001/07/30 10:41:59  MH
 - Spoolverzeichnis per F2 anbieten - ...;)

 Revision 1.24.2.12  2001/07/30 09:48:07  MH
 - Spoolverzeichnis per F2 anbieten, wenn UUZ-Spool eingetragen wurde

 Revision 1.24.2.11  2001/07/11 14:38:56  MH
 - Multi-Nntp: Onlinehilfe einblenden

 Revision 1.24.2.10  2001/07/11 12:56:50  MH
 - Multi-Nntp: Mu auch bei Break im Nntp-Men das BFG schreiben

 Revision 1.24.2.9  2001/07/11 12:54:27  MH
 - Multi-Nntp: Mu auch bei Break im Nntp-Men das BFG schreiben

 Revision 1.24.2.8  2001/07/11 12:18:01  MH
 - Multi-Nntp jetzt im Nntp-Men als Button implementiert

 Revision 1.24.2.7  2001/07/08 22:31:08  MH
 - RFC/PPP-Boxmen: Einige Inkonsistenzen beseitigt

 Revision 1.24.2.6  2001/07/08 00:32:32  MH
 - Client Einstellungen: Dialog fr Spool-Verzeichnisse hinzugefgt

 Revision 1.24.2.5  2001/07/07 13:21:01  MH
 - Geschweifte Klammern aus den Logs des vorherigen co entfernt

 Revision 1.24.2.4  2001/07/07 13:02:41  MH
 - RFC/PPP: Gendertes Profile fr 'Pakete mitsenden'
   (mu in XPDEFINE.INC mit $DEFINE MAX aktiviert werden)

 Revision 1.24.2.3  2001/07/04 17:22:26  MH
 - DialinNummernListe angelegt (F2-Men)

 Revision 1.24.2.2  2001/07/03 17:44:52  MH
 - RFC/PPP-Boxmen berarbeitet (mehr F2-Untersttzung)

 Revision 1.24.2.1  2001/06/24 22:42:04  mm
 Teames -> Teams

 Revision 1.24  2001/01/29 22:08:47  MH
 RFC/PPP:
 - Einige Grenzen erweitert

 Revision 1.23  2001/01/05 21:59:51  MH
 - SmtpAuth um weitere Elemente erweitert

 Revision 1.22  2001/01/05 17:16:15  MH
 - cut and paste BugFix...;-)

 Revision 1.21  2001/01/05 13:13:41  MH
 - dis/enabled < > de/aktiviert

 Revision 1.20  2001/01/04 22:08:14  MH
 - DialInAccount von 25 auf 40 Zeichen erhht

 Revision 1.19  2000/12/16 19:06:00  MH
 RFC/PPP:
 - Einige Erweiterungen im Boxmen

 Revision 1.18  2000/10/27 12:01:04  MH
 Optisches fixing...

 Revision 1.17  2000/10/27 11:46:27  MH
 RFC/PPP: Optischer Fix im Zugangsmen

 Revision 1.16  2000/10/27 11:38:58  MH
 RFC/PPP: Kleiner Umbau des Boxmens

 - ReplaceOwn bei weiteren Boxen hinzugefgt

 Revision 1.15  2000/10/11 17:13:59  MH
 RFC/PPP: Fix:
 - String fr UUZ-In/Out zu kurz

 Revision 1.14  2000/10/06 21:14:40  MH
 RFC/PPP:
 Artikel durch Rcklufer ersetzen nun im Boxmen einzustellen

 Revision 1.13  2000/08/12 09:16:14  MH
 [RFC/PPP] Fix: Maximale Artikelanzahl bei Neubestellung
 darf nicht grer 32K sein - nun begrenzt -

 Revision 1.12  2000/08/01 21:18:08  MH
 RFC/PPP: Angaben fr maximale Mail/News-Gre sind Bytes,
 daher fr Mails das Limit 7-Stellig ermglicht

 Revision 1.11  2000/07/31 19:15:44  MH
 RFC/PPP: Maximale Gre einer E-Mail kann konfiguriert werden

 Revision 1.10  2000/07/27 16:59:07  MH
 RFC/PPP: Einige Grenzen erweitert und mit Mglichkeit
          der Einstellung der Hangup-Zeit ergnzt

 Revision 1.9  2000/07/26 21:34:22  MH
 NNTP-DupeBase nun 6-Stellig

 Revision 1.8  2000/07/26 14:20:43  MH
 Client-Zugang:
 Telefon: 'W' (fr wait) in der Eingabemaske zulssig

 Revision 1.7  2000/07/16 00:41:25  MH
 RFC/PPP: Kleine nderung fr XP3P und Men-Inkonsistenz beseitigt

 Revision 1.6  2000/07/11 18:35:18  MH
 RFC/PPP: String 'NNTP-Einstellungen' in die Resourcen eingebunden

 Revision 1.5  2000/07/07 20:01:23  MH
 RFC/PPP: SpoolDirs werden nun nur bei nderung dessen
          ber das Clientmen berschrieben

 Revision 1.4  2000/07/03 19:51:48  rb
 xpdefine.inc included

 Revision 1.3  2000/07/03 12:21:20  MH
 - no coment...

 Revision 1.2  2000/07/03 12:18:00  MH
 - LogInfos unten hinzugefgt

}
